use lox::BridgeAuth;
use std::fs::File;
use std::io::Write;

fn main() {
    let bridgedb_pubkey_filename = "bridgedb_pubkey.json";
    let lox_auth_privkeys_filename = "lox_auth.json";
    let lox_auth_pubkeys_filename = "lox_auth_pubkeys.json";

    // import bridgedb pubkey
    // note: currently no checks for valid data
    let bridgedb_pubkey_infile = File::open(bridgedb_pubkey_filename).unwrap();
    let bridgedb_pubkey = serde_json::from_reader(bridgedb_pubkey_infile).unwrap();

    // create new bridge authority (implicitly generates keys)
    let lox_auth = BridgeAuth::new(bridgedb_pubkey);

    // TODO: serialize lox_auth private keys

    // vector of public keys (to serialize)
    let lox_auth_pubkeys = vec![
        lox_auth.lox_pub,
        lox_auth.migration_pub,
        lox_auth.migrationkey_pub,
        lox_auth.reachability_pub,
        lox_auth.invitation_pub,
    ];

    // output lox_auth public keys
    let mut lox_auth_pubkeys_outfile =
        File::create(lox_auth_pubkeys_filename).expect("Failed to create lox_auth pubkeys file");
    write!(
        lox_auth_pubkeys_outfile,
        "{}",
        serde_json::to_string(&lox_auth_pubkeys).unwrap()
    )
    .expect("Failed to write to lox_auth pubkeys file");
}
